# Coscine.ApiClient.Core.Model.ProjectDto
Represents a data transfer object (DTO) for project information.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Id** | **Guid** | Unique identifier for the project. | [optional] 
**Pid** | **string** | Persistent identifier for the project. | [optional] 
**Name** | **string** | Name of the project. | [optional] 
**Description** | **string** | Description of the project. | [optional] 
**StartDate** | **DateTime** | Start date of the project. | [optional] 
**EndDate** | **DateTime** | End date of the project. | [optional] 
**Keywords** | **List&lt;string&gt;** | Collection of keywords associated with the project. | [optional] 
**DisplayName** | **string** | Display name of the project. | [optional] 
**PrincipleInvestigators** | **string** | Principal investigators involved in the project. | [optional] 
**GrantId** | **string** | Grant ID associated with the project. | [optional] 
**Visibility** | [**VisibilityDto**](VisibilityDto.md) |  | [optional] 
**Disciplines** | [**List&lt;DisciplineDto&gt;**](DisciplineDto.md) | Disciplines related to the project. | [optional] 
**Organizations** | [**List&lt;OrganizationDto&gt;**](OrganizationDto.md) | Organizations associated with the project. | [optional] 
**Slug** | **string** | Slug for the project. | [optional] 
**Creator** | [**UserMinimalDto**](UserMinimalDto.md) |  | [optional] 
**CreationDate** | **DateTime?** | Date of creation of the project. | [optional] 
**SubProjects** | [**List&lt;ProjectDto&gt;**](ProjectDto.md) | Collection of sub-projects associated with this project. | [optional] 
**Parent** | [**ProjectMinimalDto**](ProjectMinimalDto.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

