# Coscine.ApiClient.Core.Model.ResourceDto
Represents a Data Transfer Object (DTO) for resource details.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Id** | **Guid** | Unique identifier for the resource. | [optional] 
**Pid** | **string** | Persistent identifier for the resource. | [optional] 
**Type** | [**ResourceTypeDto**](ResourceTypeDto.md) |  | [optional] 
**Name** | **string** | Name of the resource. | [optional] 
**DisplayName** | **string** | Display name of the resource. | [optional] 
**Description** | **string** | Description of the resource. | [optional] 
**Keywords** | **List&lt;string&gt;** | Keywords associated with the resource. | [optional] 
**License** | [**LicenseDto**](LicenseDto.md) |  | [optional] 
**UsageRights** | **string** | Usage rights associated with the resource. | [optional] 
**MetadataLocalCopy** | **bool** | Setting for creating a local copy of the metadata. | [optional] 
**MetadataExtraction** | **bool** | Setting for metadata extraction. | [optional] 
**ApplicationProfile** | [**ApplicationProfileMinimalDto**](ApplicationProfileMinimalDto.md) |  | [optional] 
**FixedValues** | **Dictionary&lt;string, Dictionary&lt;string, List&lt;FixedValueForResourceManipulationDto&gt;&gt;&gt;** | Fixed values associated with resource manipulation.  This dictionary may contain multiple levels and is structured as follows:  Dictionary (Key: string) -&gt; Dictionary (Key: string) -&gt; List of FixedValueForResourceManipulationDto. | [optional] 
**Disciplines** | [**List&lt;DisciplineDto&gt;**](DisciplineDto.md) | Disciplines associated with the resource. | [optional] 
**Visibility** | [**VisibilityDto**](VisibilityDto.md) |  | [optional] 
**DateCreated** | **DateTime?** | Date when the resource was created. | [optional] 
**Creator** | [**UserMinimalDto**](UserMinimalDto.md) |  | [optional] 
**Archived** | **bool** | Indicates whether the resource is archived. | [optional] 
**Projects** | [**List&lt;ProjectMinimalDto&gt;**](ProjectMinimalDto.md) | The projects associated with the resource. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

