# Coscine.ApiClient.Core.Model.UserDto
Represents a Data Transfer Object (DTO) for user-related information.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Id** | **Guid** | The unique identifier of the user. | [optional] 
**DisplayName** | **string** | The display name of the user. | [optional] 
**GivenName** | **string** | The given name of the user. | [optional] 
**FamilyName** | **string** | The family name of the user. | [optional] 
**Emails** | [**List&lt;UserEmailDto&gt;**](UserEmailDto.md) | The email addresses associated with the user. | [optional] 
**Title** | [**TitleDto**](TitleDto.md) |  | [optional] 
**Language** | [**LanguageDto**](LanguageDto.md) |  | [optional] 
**AreToSAccepted** | **bool** | Indicates if the terms of service are accepted by the user. | [optional] 
**LatestActivity** | **DateTime?** | The date and time of the latest activity of the user. | [optional] 
**Disciplines** | [**List&lt;DisciplineDto&gt;**](DisciplineDto.md) | The disciplines associated with the user. | [optional] 
**Organizations** | [**List&lt;UserOrganizationDto&gt;**](UserOrganizationDto.md) | The organizations associated with the user. | [optional] 
**Institutes** | [**List&lt;UserInstituteDto&gt;**](UserInstituteDto.md) | The institutes associated with the user. | [optional] 
**Identities** | [**List&lt;IdentityProviderDto&gt;**](IdentityProviderDto.md) | The identity providers associated with the user. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

