/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for an activity log.
    /// </summary>
    [DataContract(Name = "ActivityLogDto")]
    public partial class ActivityLogDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ActivityLogDto" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="apiPath">apiPath.</param>
        /// <param name="httpAction">httpAction.</param>
        /// <param name="controllerName">controllerName.</param>
        /// <param name="actionName">actionName.</param>
        /// <param name="userId">userId.</param>
        /// <param name="activityTimestamp">activityTimestamp.</param>
        public ActivityLogDto(Guid id = default(Guid), string apiPath = default(string), string httpAction = default(string), string controllerName = default(string), string actionName = default(string), Guid userId = default(Guid), DateTime activityTimestamp = default(DateTime))
        {
            this.Id = id;
            this.ApiPath = apiPath;
            this.HttpAction = httpAction;
            this.ControllerName = controllerName;
            this.ActionName = actionName;
            this.UserId = userId;
            this.ActivityTimestamp = activityTimestamp;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// Gets or Sets ApiPath
        /// </summary>
        [DataMember(Name = "apiPath", EmitDefaultValue = false)]
        public string ApiPath { get; set; }

        /// <summary>
        /// Gets or Sets HttpAction
        /// </summary>
        [DataMember(Name = "httpAction", EmitDefaultValue = false)]
        public string HttpAction { get; set; }

        /// <summary>
        /// Gets or Sets ControllerName
        /// </summary>
        [DataMember(Name = "controllerName", EmitDefaultValue = true)]
        public string ControllerName { get; set; }

        /// <summary>
        /// Gets or Sets ActionName
        /// </summary>
        [DataMember(Name = "actionName", EmitDefaultValue = true)]
        public string ActionName { get; set; }

        /// <summary>
        /// Gets or Sets UserId
        /// </summary>
        [DataMember(Name = "userId", EmitDefaultValue = false)]
        public Guid UserId { get; set; }

        /// <summary>
        /// Gets or Sets ActivityTimestamp
        /// </summary>
        [DataMember(Name = "activityTimestamp", EmitDefaultValue = false)]
        public DateTime ActivityTimestamp { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ActivityLogDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ApiPath: ").Append(ApiPath).Append("\n");
            sb.Append("  HttpAction: ").Append(HttpAction).Append("\n");
            sb.Append("  ControllerName: ").Append(ControllerName).Append("\n");
            sb.Append("  ActionName: ").Append(ActionName).Append("\n");
            sb.Append("  UserId: ").Append(UserId).Append("\n");
            sb.Append("  ActivityTimestamp: ").Append(ActivityTimestamp).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
