/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of an API token.
    /// </summary>
    [DataContract(Name = "ApiTokenForCreationDto")]
    public partial class ApiTokenForCreationDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ApiTokenForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ApiTokenForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ApiTokenForCreationDto" /> class.
        /// </summary>
        /// <param name="name">Gets or sets the name of the API token. (required).</param>
        /// <param name="expiresInDays">Gets or sets the expiration duration of the token in days. (required).</param>
        public ApiTokenForCreationDto(string name = default(string), int expiresInDays = default(int))
        {
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new ArgumentNullException("name is a required property for ApiTokenForCreationDto and cannot be null");
            }
            this.Name = name;
            this.ExpiresInDays = expiresInDays;
        }

        /// <summary>
        /// Gets or sets the name of the API token.
        /// </summary>
        /// <value>Gets or sets the name of the API token.</value>
        [DataMember(Name = "name", IsRequired = true, EmitDefaultValue = true)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the expiration duration of the token in days.
        /// </summary>
        /// <value>Gets or sets the expiration duration of the token in days.</value>
        [DataMember(Name = "expiresInDays", IsRequired = true, EmitDefaultValue = true)]
        public int ExpiresInDays { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ApiTokenForCreationDto {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  ExpiresInDays: ").Append(ExpiresInDays).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Name (string) minLength
            if (this.Name != null && this.Name.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Name, length must be greater than 1.", new [] { "Name" });
            }

            // ExpiresInDays (int) maximum
            if (this.ExpiresInDays > (int)370)
            {
                yield return new ValidationResult("Invalid value for ExpiresInDays, must be a value less than or equal to 370.", new [] { "ExpiresInDays" });
            }

            // ExpiresInDays (int) minimum
            if (this.ExpiresInDays < (int)7)
            {
                yield return new ValidationResult("Invalid value for ExpiresInDays, must be a value greater than or equal to 7.", new [] { "ExpiresInDays" });
            }

            yield break;
        }
    }

}
