/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a GitLab project data transfer object (DTO).
    /// </summary>
    [DataContract(Name = "GitlabProjectDto")]
    public partial class GitlabProjectDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GitlabProjectDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier for the GitLab project..</param>
        /// <param name="archived">Indicates if the GitLab project is archived..</param>
        /// <param name="name">The name of the GitLab project..</param>
        /// <param name="nameWithNamespace">The full name of the GitLab project including namespace..</param>
        /// <param name="description">A brief description of the GitLab project..</param>
        /// <param name="defaultBranch">The default branch of the GitLab project..</param>
        /// <param name="path">The path of the GitLab project..</param>
        /// <param name="pathWithNamespace">The path of the GitLab project including namespace..</param>
        /// <param name="lastActivityAt">The timestamp of the last activity related to the GitLab project..</param>
        /// <param name="createdAt">The creation timestamp of the GitLab project..</param>
        /// <param name="webUrl">The URL to view the GitLab project in a web browser..</param>
        /// <param name="httpUrlToRepo">The HTTP URL to access the GitLab project repository..</param>
        /// <param name="sshUrlToRepo">The SSH URL to access the GitLab project repository..</param>
        public GitlabProjectDto(int id = default(int), bool archived = default(bool), string name = default(string), string nameWithNamespace = default(string), string description = default(string), string defaultBranch = default(string), string path = default(string), string pathWithNamespace = default(string), string lastActivityAt = default(string), string createdAt = default(string), string webUrl = default(string), string httpUrlToRepo = default(string), string sshUrlToRepo = default(string))
        {
            this.Id = id;
            this.Archived = archived;
            this.Name = name;
            this.NameWithNamespace = nameWithNamespace;
            this.Description = description;
            this.DefaultBranch = defaultBranch;
            this.Path = path;
            this.PathWithNamespace = pathWithNamespace;
            this.LastActivityAt = lastActivityAt;
            this.CreatedAt = createdAt;
            this.WebUrl = webUrl;
            this.HttpUrlToRepo = httpUrlToRepo;
            this.SshUrlToRepo = sshUrlToRepo;
        }

        /// <summary>
        /// The unique identifier for the GitLab project.
        /// </summary>
        /// <value>The unique identifier for the GitLab project.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public int Id { get; set; }

        /// <summary>
        /// Indicates if the GitLab project is archived.
        /// </summary>
        /// <value>Indicates if the GitLab project is archived.</value>
        [DataMember(Name = "archived", EmitDefaultValue = true)]
        public bool Archived { get; set; }

        /// <summary>
        /// The name of the GitLab project.
        /// </summary>
        /// <value>The name of the GitLab project.</value>
        [DataMember(Name = "name", EmitDefaultValue = false)]
        public string Name { get; set; }

        /// <summary>
        /// The full name of the GitLab project including namespace.
        /// </summary>
        /// <value>The full name of the GitLab project including namespace.</value>
        [DataMember(Name = "nameWithNamespace", EmitDefaultValue = false)]
        public string NameWithNamespace { get; set; }

        /// <summary>
        /// A brief description of the GitLab project.
        /// </summary>
        /// <value>A brief description of the GitLab project.</value>
        [DataMember(Name = "description", EmitDefaultValue = false)]
        public string Description { get; set; }

        /// <summary>
        /// The default branch of the GitLab project.
        /// </summary>
        /// <value>The default branch of the GitLab project.</value>
        [DataMember(Name = "defaultBranch", EmitDefaultValue = false)]
        public string DefaultBranch { get; set; }

        /// <summary>
        /// The path of the GitLab project.
        /// </summary>
        /// <value>The path of the GitLab project.</value>
        [DataMember(Name = "path", EmitDefaultValue = false)]
        public string Path { get; set; }

        /// <summary>
        /// The path of the GitLab project including namespace.
        /// </summary>
        /// <value>The path of the GitLab project including namespace.</value>
        [DataMember(Name = "pathWithNamespace", EmitDefaultValue = false)]
        public string PathWithNamespace { get; set; }

        /// <summary>
        /// The timestamp of the last activity related to the GitLab project.
        /// </summary>
        /// <value>The timestamp of the last activity related to the GitLab project.</value>
        [DataMember(Name = "lastActivityAt", EmitDefaultValue = false)]
        public string LastActivityAt { get; set; }

        /// <summary>
        /// The creation timestamp of the GitLab project.
        /// </summary>
        /// <value>The creation timestamp of the GitLab project.</value>
        [DataMember(Name = "createdAt", EmitDefaultValue = false)]
        public string CreatedAt { get; set; }

        /// <summary>
        /// The URL to view the GitLab project in a web browser.
        /// </summary>
        /// <value>The URL to view the GitLab project in a web browser.</value>
        [DataMember(Name = "webUrl", EmitDefaultValue = false)]
        public string WebUrl { get; set; }

        /// <summary>
        /// The HTTP URL to access the GitLab project repository.
        /// </summary>
        /// <value>The HTTP URL to access the GitLab project repository.</value>
        [DataMember(Name = "httpUrlToRepo", EmitDefaultValue = false)]
        public string HttpUrlToRepo { get; set; }

        /// <summary>
        /// The SSH URL to access the GitLab project repository.
        /// </summary>
        /// <value>The SSH URL to access the GitLab project repository.</value>
        [DataMember(Name = "sshUrlToRepo", EmitDefaultValue = false)]
        public string SshUrlToRepo { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GitlabProjectDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Archived: ").Append(Archived).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  NameWithNamespace: ").Append(NameWithNamespace).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  DefaultBranch: ").Append(DefaultBranch).Append("\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  PathWithNamespace: ").Append(PathWithNamespace).Append("\n");
            sb.Append("  LastActivityAt: ").Append(LastActivityAt).Append("\n");
            sb.Append("  CreatedAt: ").Append(CreatedAt).Append("\n");
            sb.Append("  WebUrl: ").Append(WebUrl).Append("\n");
            sb.Append("  HttpUrlToRepo: ").Append(HttpUrlToRepo).Append("\n");
            sb.Append("  SshUrlToRepo: ").Append(SshUrlToRepo).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
