/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for extracted metadata within a tree structure, extending the base TreeDto.
    /// </summary>
    [DataContract(Name = "MetadataTreeExtractedDto")]
    public partial class MetadataTreeExtractedDto : IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public TreeDataType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeExtractedDto" /> class.
        /// </summary>
        /// <param name="path">The path of the tree item..</param>
        /// <param name="type">type.</param>
        /// <param name="metadataId">Gets the identifier of the metadata extraction graph..</param>
        /// <param name="rawDataId">Gets the identifier of the raw data extraction graph..</param>
        /// <param name="definition">definition.</param>
        public MetadataTreeExtractedDto(string path = default(string), TreeDataType? type = default(TreeDataType?), string metadataId = default(string), string rawDataId = default(string), RdfDefinitionDto definition = default(RdfDefinitionDto))
        {
            this.Path = path;
            this.Type = type;
            this.MetadataId = metadataId;
            this.RawDataId = rawDataId;
            this.Definition = definition;
        }

        /// <summary>
        /// The path of the tree item.
        /// </summary>
        /// <value>The path of the tree item.</value>
        [DataMember(Name = "path", EmitDefaultValue = false)]
        public string Path { get; set; }

        /// <summary>
        /// Gets the identifier of the metadata extraction graph.
        /// </summary>
        /// <value>Gets the identifier of the metadata extraction graph.</value>
        [DataMember(Name = "metadataId", EmitDefaultValue = false)]
        public string MetadataId { get; set; }

        /// <summary>
        /// Gets the identifier of the raw data extraction graph.
        /// </summary>
        /// <value>Gets the identifier of the raw data extraction graph.</value>
        [DataMember(Name = "rawDataId", EmitDefaultValue = true)]
        public string RawDataId { get; set; }

        /// <summary>
        /// Gets or Sets Definition
        /// </summary>
        [DataMember(Name = "definition", EmitDefaultValue = false)]
        public RdfDefinitionDto Definition { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MetadataTreeExtractedDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  MetadataId: ").Append(MetadataId).Append("\n");
            sb.Append("  RawDataId: ").Append(RawDataId).Append("\n");
            sb.Append("  Definition: ").Append(Definition).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
