/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) for deleting a specific version of metadata.
    /// </summary>
    [DataContract(Name = "MetadataTreeForDeletionDto")]
    public partial class MetadataTreeForDeletionDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeForDeletionDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MetadataTreeForDeletionDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeForDeletionDto" /> class.
        /// </summary>
        /// <param name="path">Gets or initializes the path of the metadata tree. (required).</param>
        /// <param name="varVersion">Gets or initializes the version of the metadata tree to be deleted. (required).</param>
        /// <param name="invalidatedBy">Gets or initializes the invalidation entity. (required).</param>
        public MetadataTreeForDeletionDto(string path = default(string), long varVersion = default(long), string invalidatedBy = default(string))
        {
            // to ensure "path" is required (not null)
            if (path == null)
            {
                throw new ArgumentNullException("path is a required property for MetadataTreeForDeletionDto and cannot be null");
            }
            this.Path = path;
            this.VarVersion = varVersion;
            // to ensure "invalidatedBy" is required (not null)
            if (invalidatedBy == null)
            {
                throw new ArgumentNullException("invalidatedBy is a required property for MetadataTreeForDeletionDto and cannot be null");
            }
            this.InvalidatedBy = invalidatedBy;
        }

        /// <summary>
        /// Gets or initializes the path of the metadata tree.
        /// </summary>
        /// <value>Gets or initializes the path of the metadata tree.</value>
        [DataMember(Name = "path", IsRequired = true, EmitDefaultValue = true)]
        public string Path { get; set; }

        /// <summary>
        /// Gets or initializes the version of the metadata tree to be deleted.
        /// </summary>
        /// <value>Gets or initializes the version of the metadata tree to be deleted.</value>
        [DataMember(Name = "version", IsRequired = true, EmitDefaultValue = true)]
        public long VarVersion { get; set; }

        /// <summary>
        /// Gets or initializes the invalidation entity.
        /// </summary>
        /// <value>Gets or initializes the invalidation entity.</value>
        [DataMember(Name = "invalidatedBy", IsRequired = true, EmitDefaultValue = true)]
        public string InvalidatedBy { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MetadataTreeForDeletionDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  VarVersion: ").Append(VarVersion).Append("\n");
            sb.Append("  InvalidatedBy: ").Append(InvalidatedBy).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Path (string) minLength
            if (this.Path != null && this.Path.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Path, length must be greater than 1.", new [] { "Path" });
            }

            yield break;
        }
    }

}
