/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for an organization, including its ROR (Research Organization Registry) ID, display name, and email address.
    /// </summary>
    [DataContract(Name = "OrganizationDto")]
    public partial class OrganizationDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OrganizationDto" /> class.
        /// </summary>
        /// <param name="uri">The ROR (Research Organization Registry) ID of the organization..</param>
        /// <param name="displayName">The display name of the organization..</param>
        /// <param name="email">The email address of the organization..</param>
        /// <param name="publicationAdvisoryService">publicationAdvisoryService.</param>
        public OrganizationDto(string uri = default(string), string displayName = default(string), string email = default(string), PublicationAdvisoryServiceDto publicationAdvisoryService = default(PublicationAdvisoryServiceDto))
        {
            this.Uri = uri;
            this.DisplayName = displayName;
            this.Email = email;
            this.PublicationAdvisoryService = publicationAdvisoryService;
        }

        /// <summary>
        /// The ROR (Research Organization Registry) ID of the organization.
        /// </summary>
        /// <value>The ROR (Research Organization Registry) ID of the organization.</value>
        [DataMember(Name = "uri", EmitDefaultValue = false)]
        public string Uri { get; set; }

        /// <summary>
        /// The display name of the organization.
        /// </summary>
        /// <value>The display name of the organization.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = false)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The email address of the organization.
        /// </summary>
        /// <value>The email address of the organization.</value>
        [DataMember(Name = "email", EmitDefaultValue = true)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets PublicationAdvisoryService
        /// </summary>
        [DataMember(Name = "publicationAdvisoryService", EmitDefaultValue = false)]
        public PublicationAdvisoryServiceDto PublicationAdvisoryService { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class OrganizationDto {\n");
            sb.Append("  Uri: ").Append(Uri).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  PublicationAdvisoryService: ").Append(PublicationAdvisoryService).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
