/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the metadata view for a resource&#39;s content page.
    /// </summary>
    [DataContract(Name = "ResourceContentPageMetadataViewDto")]
    public partial class ResourceContentPageMetadataViewDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceContentPageMetadataViewDto" /> class.
        /// </summary>
        /// <param name="editableDataUrl">Indicates if a data URL can be provided and is editable..</param>
        /// <param name="editableKey">Indicates if a key can be provided and is editable..</param>
        public ResourceContentPageMetadataViewDto(bool editableDataUrl = default(bool), bool editableKey = default(bool))
        {
            this.EditableDataUrl = editableDataUrl;
            this.EditableKey = editableKey;
        }

        /// <summary>
        /// Indicates if a data URL can be provided and is editable.
        /// </summary>
        /// <value>Indicates if a data URL can be provided and is editable.</value>
        [DataMember(Name = "editableDataUrl", EmitDefaultValue = true)]
        public bool EditableDataUrl { get; set; }

        /// <summary>
        /// Indicates if a key can be provided and is editable.
        /// </summary>
        /// <value>Indicates if a key can be provided and is editable.</value>
        [DataMember(Name = "editableKey", EmitDefaultValue = true)]
        public bool EditableKey { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceContentPageMetadataViewDto {\n");
            sb.Append("  EditableDataUrl: ").Append(EditableDataUrl).Append("\n");
            sb.Append("  EditableKey: ").Append(EditableKey).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
