/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a minimal Data Transfer Object (DTO) for a resource type.
    /// </summary>
    [DataContract(Name = "ResourceTypeMinimalDto")]
    public partial class ResourceTypeMinimalDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeMinimalDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier of the resource type..</param>
        /// <param name="specificType">The specific type of the resource..</param>
        public ResourceTypeMinimalDto(Guid id = default(Guid), string specificType = default(string))
        {
            this.Id = id;
            this.SpecificType = specificType;
        }

        /// <summary>
        /// The unique identifier of the resource type.
        /// </summary>
        /// <value>The unique identifier of the resource type.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// The specific type of the resource.
        /// </summary>
        /// <value>The specific type of the resource.</value>
        [DataMember(Name = "specificType", EmitDefaultValue = false)]
        public string SpecificType { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceTypeMinimalDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  SpecificType: ").Append(SpecificType).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
