/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the Data Transfer Object (DTO) for terms of service information.
    /// </summary>
    [DataContract(Name = "TermsOfServiceDto")]
    public partial class TermsOfServiceDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TermsOfServiceDto" /> class.
        /// </summary>
        /// <param name="varVersion">The version of the terms of service..</param>
        /// <param name="href">The URI point to the content of ToS&#39; version.</param>
        /// <param name="isCurrent">Indicates whether these terms of service are current or not..</param>
        public TermsOfServiceDto(string varVersion = default(string), string href = default(string), bool isCurrent = default(bool))
        {
            this.VarVersion = varVersion;
            this.Href = href;
            this.IsCurrent = isCurrent;
        }

        /// <summary>
        /// The version of the terms of service.
        /// </summary>
        /// <value>The version of the terms of service.</value>
        [DataMember(Name = "version", EmitDefaultValue = false)]
        public string VarVersion { get; set; }

        /// <summary>
        /// The URI point to the content of ToS&#39; version
        /// </summary>
        /// <value>The URI point to the content of ToS&#39; version</value>
        [DataMember(Name = "href", EmitDefaultValue = false)]
        public string Href { get; set; }

        /// <summary>
        /// Indicates whether these terms of service are current or not.
        /// </summary>
        /// <value>Indicates whether these terms of service are current or not.</value>
        [DataMember(Name = "isCurrent", EmitDefaultValue = true)]
        public bool IsCurrent { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TermsOfServiceDto {\n");
            sb.Append("  VarVersion: ").Append(VarVersion).Append("\n");
            sb.Append("  Href: ").Append(Href).Append("\n");
            sb.Append("  IsCurrent: ").Append(IsCurrent).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
