/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for user-related information.
    /// </summary>
    [DataContract(Name = "UserDto")]
    public partial class UserDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier of the user..</param>
        /// <param name="displayName">The display name of the user..</param>
        /// <param name="givenName">The given name of the user..</param>
        /// <param name="familyName">The family name of the user..</param>
        /// <param name="emails">The email addresses associated with the user..</param>
        /// <param name="title">title.</param>
        /// <param name="language">language.</param>
        /// <param name="areToSAccepted">Indicates if the terms of service are accepted by the user..</param>
        /// <param name="latestActivity">The date and time of the latest activity of the user..</param>
        /// <param name="disciplines">The disciplines associated with the user..</param>
        /// <param name="organizations">The organizations associated with the user..</param>
        /// <param name="institutes">The institutes associated with the user..</param>
        /// <param name="identities">The identity providers associated with the user..</param>
        public UserDto(Guid id = default(Guid), string displayName = default(string), string givenName = default(string), string familyName = default(string), List<UserEmailDto> emails = default(List<UserEmailDto>), TitleDto title = default(TitleDto), LanguageDto language = default(LanguageDto), bool areToSAccepted = default(bool), DateTime? latestActivity = default(DateTime?), List<DisciplineDto> disciplines = default(List<DisciplineDto>), List<UserOrganizationDto> organizations = default(List<UserOrganizationDto>), List<UserInstituteDto> institutes = default(List<UserInstituteDto>), List<IdentityProviderDto> identities = default(List<IdentityProviderDto>))
        {
            this.Id = id;
            this.DisplayName = displayName;
            this.GivenName = givenName;
            this.FamilyName = familyName;
            this.Emails = emails;
            this.Title = title;
            this.Language = language;
            this.AreToSAccepted = areToSAccepted;
            this.LatestActivity = latestActivity;
            this.Disciplines = disciplines;
            this.Organizations = organizations;
            this.Institutes = institutes;
            this.Identities = identities;
        }

        /// <summary>
        /// The unique identifier of the user.
        /// </summary>
        /// <value>The unique identifier of the user.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// The display name of the user.
        /// </summary>
        /// <value>The display name of the user.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = false)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The given name of the user.
        /// </summary>
        /// <value>The given name of the user.</value>
        [DataMember(Name = "givenName", EmitDefaultValue = false)]
        public string GivenName { get; set; }

        /// <summary>
        /// The family name of the user.
        /// </summary>
        /// <value>The family name of the user.</value>
        [DataMember(Name = "familyName", EmitDefaultValue = false)]
        public string FamilyName { get; set; }

        /// <summary>
        /// The email addresses associated with the user.
        /// </summary>
        /// <value>The email addresses associated with the user.</value>
        [DataMember(Name = "emails", EmitDefaultValue = false)]
        public List<UserEmailDto> Emails { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name = "title", EmitDefaultValue = false)]
        public TitleDto Title { get; set; }

        /// <summary>
        /// Gets or Sets Language
        /// </summary>
        [DataMember(Name = "language", EmitDefaultValue = false)]
        public LanguageDto Language { get; set; }

        /// <summary>
        /// Indicates if the terms of service are accepted by the user.
        /// </summary>
        /// <value>Indicates if the terms of service are accepted by the user.</value>
        [DataMember(Name = "areToSAccepted", EmitDefaultValue = true)]
        public bool AreToSAccepted { get; set; }

        /// <summary>
        /// The date and time of the latest activity of the user.
        /// </summary>
        /// <value>The date and time of the latest activity of the user.</value>
        [DataMember(Name = "latestActivity", EmitDefaultValue = true)]
        public DateTime? LatestActivity { get; set; }

        /// <summary>
        /// The disciplines associated with the user.
        /// </summary>
        /// <value>The disciplines associated with the user.</value>
        [DataMember(Name = "disciplines", EmitDefaultValue = false)]
        public List<DisciplineDto> Disciplines { get; set; }

        /// <summary>
        /// The organizations associated with the user.
        /// </summary>
        /// <value>The organizations associated with the user.</value>
        [DataMember(Name = "organizations", EmitDefaultValue = false)]
        public List<UserOrganizationDto> Organizations { get; set; }

        /// <summary>
        /// The institutes associated with the user.
        /// </summary>
        /// <value>The institutes associated with the user.</value>
        [DataMember(Name = "institutes", EmitDefaultValue = false)]
        public List<UserInstituteDto> Institutes { get; set; }

        /// <summary>
        /// The identity providers associated with the user.
        /// </summary>
        /// <value>The identity providers associated with the user.</value>
        [DataMember(Name = "identities", EmitDefaultValue = false)]
        public List<IdentityProviderDto> Identities { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class UserDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  GivenName: ").Append(GivenName).Append("\n");
            sb.Append("  FamilyName: ").Append(FamilyName).Append("\n");
            sb.Append("  Emails: ").Append(Emails).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Language: ").Append(Language).Append("\n");
            sb.Append("  AreToSAccepted: ").Append(AreToSAccepted).Append("\n");
            sb.Append("  LatestActivity: ").Append(LatestActivity).Append("\n");
            sb.Append("  Disciplines: ").Append(Disciplines).Append("\n");
            sb.Append("  Organizations: ").Append(Organizations).Append("\n");
            sb.Append("  Institutes: ").Append(Institutes).Append("\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
